/*
 * #%L
 * EUGene :: EUGene
 * 
 * $Id: ModelReader.java 906 2010-05-16 12:19:55Z tchemit $
 * $HeadURL: http://svn.nuiton.org/svn/eugene/tags/eugene-2.1/eugene/src/main/java/org/nuiton/eugene/ModelReader.java $
 * %%
 * Copyright (C) 2004 - 2010 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */

package org.nuiton.eugene;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.nuiton.eugene.models.Model;

import java.io.File;

/**
 * ModelReader TODO real doc :)
 * <p/>
 * Created: 26 oct. 2009
 *
 * @author fdesbois <fdesbois@codelutin.com>
 * @version $Id: ModelReader.java 906 2010-05-16 12:19:55Z tchemit $
 * @param <M> Model to create from reading input files
 */
public abstract class ModelReader<M extends Model> {

    private static final Log log = LogFactory.getLog(ModelReader.class);

    /** date de derniere modification de la source la plus recente */
    protected long lastModifiedSource;

    protected void setLastModifiedSource(File... files) {
        for (File file : files) {
            if (file.lastModified() > getLastModifiedSource()) {
                lastModifiedSource = file.lastModified();

                if (log.isDebugEnabled()) {
                    log.debug("source date: " + lastModifiedSource
                              + " files[i] date: " + file.lastModified() +
                              "(" + file + ")");
                }
            }
        }
    }

    /**
     * @return the last modified file source (says the newer incoming file)
     */
    public long getLastModifiedSource() {
        return lastModifiedSource;
    }

    /**
     * Read files to produce a memory model.
     *
     * @param file files to read
     * @return the new model builded from files
     */
    public abstract M read(File... file);

}
